SystemOrganization addCategory: #'Fuel-Tests'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Cluster'!
SystemOrganization addCategory: #'Fuel-Core-Analyzer'!

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:11'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 13:39'!
fuelSerializer

	^ FLByteStringClusterSerializer instance! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:12'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:13'!
fuelSerializer

	^ FLSymbolClusterSerializer instance! !

!OrderedCollection methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 16:11'!
hasAnyDuplicate
	"Answers if there is an element added more than one time"

	^ self size ~= self asSet size ! !

!SmallInteger methodsFor: '*Fuel' stamp: 'MartinDias 10/26/2010 14:20'!
fuelSerializer
	^ self < 0 
		ifTrue: [ FLNegativeSmallIntegerClusterSerializer instance ]
		ifFalse: [ FLPositiveSmallIntegerClusterSerializer instance ]
	! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:33'!
fuelAccept: aVisitor

	aVisitor visitObject: self.! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/26/2010 14:43'!
fuelAllInstanceVariablesDo: aBlock

	| beginIndex |

	self flag: #todo. "Ugly!!"

	(self isNamedPrimitive)
		ifTrue: [
			beginIndex := 2.
			aBlock 
				value: (self literalAt: 1) first;
				value: (self literalAt: 1) second ] 
		ifFalse: [ 
			beginIndex := 1 ].

	beginIndex to: self numLiterals
		do: [ :index | aBlock value: (self literalAt: index) ]! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
fuelSerializer 

	^ (self isNamedPrimitive)
		ifTrue:  [ FLNamedPrimitiveMethodClusterSerializer instance ]
		ifFalse: [ FLCompiledMethodClusterSerializer instance ]
! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
isNamedPrimitive 

	^ self primitive = 117! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 10:54'!
hasInstanceVariables
	"Returns whether the receiver has instance variables"
	
	^ self instSize > 0 ! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 13:56'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:27'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 10/20/2010 22:46'!
fuelSerializer 

	^ FLFloatClusterSerializer instance! !

!Integer methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:26'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!LargePositiveInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 14:21'!
fuelSerializer 

	^ FLLargePositiveIntegerClusterSerializer instance.! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:28'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLCharacterClusterSerializer instance! !

TestCase subclass: #FLClusterSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClusterSerializerTest methodsFor: 'tests' stamp: 'MartinDias 10/12/2010 16:10'!
testUniqueIds

	" 
	Inspect the mapping:
	FLClusterSerializer allSubclasses collect: [ :aClass | aClass->([aClass id] ifError: [nil]) ]
	"

	self shouldnt: [ FLClusterSerializer validateIdDistribution ] raise: Error! !

TestCase subclass: #FLSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLSerializationTest commentStamp: '<historical>' prior: 0!
I have black-box tests for testing that objects serializes and materializes well.!

FLSerializationTest subclass: #FLBasicSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/25/2010 14:24'!
testArray
	self assertSerializationEqualityOf: #(10 20)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/25/2010 14:27'!
testByteArrays

	self assertSerializationEqualityOf: { #[1 2 3 4 5 6]. #[1 2 3 4 5 6]. #[7 8 9 10 11 12]. #[7 8 9 10 11 12] }! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:00'!
testCharacter

	self assertSerializationIdentityOf: $a! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:52'!
testCyclicLinks

	| a b c materializedA |
	a := Link new..
	b := Link new.
	c := Link new.
	
	a nextLink: b.
	b nextLink: c.
	c nextLink: a.
	
	materializedA := self materialized: a.

	"We can't check using the equality of the links because hangs ad infinitum. So we only check that the structure is right."
	self assert: materializedA nextLink nextLink nextLink == materializedA.
	self deny: materializedA nextLink == materializedA.
	self deny: materializedA nextLink nextLink == materializedA.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:59'!
testDictionary

	self assertSerializationEqualityOf: (Dictionary with: 1->2).! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 19:46'!
testEmptyArray
	self assertSerializationEqualityOf: #()! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 19:45'!
testEmptyDictionary

	self assertSerializationEqualityOf: Dictionary new! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 19:46'!
testEmptyOrderedCollection

	self assertSerializationEqualityOf: OrderedCollection new! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:59'!
testFalse

	self assertSerializationIdentityOf: false! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/21/2010 10:49'!
testFloat
	
	self assertSerializationEqualityOf: 180.0! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:54'!
testLargeNegativeInteger

	self assertSerializationEqualityOf: -354314316134313999999999.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:54'!
testLargePositiveInteger

	self assertSerializationEqualityOf: 354314316134313999999999.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:56'!
testNil

	self assertSerializationIdentityOf: nil! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testOrderedCollection

	self assertSerializationEqualityOf: (OrderedCollection with: 10 with: 20)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:56'!
testPair

	self assertSerializationEqualityOf:
			(Pair new
				left: 10;
				right: 20;
				yourself)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:57'!
testPoint

	self assertSerializationEqualityOf: 10@20! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 14:57'!
testRectangle
	
	self assertSerializationEqualityOf: (10@20 corner: 30@40)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:57'!
testSmallInteger

	self assertSerializationIdentityOf: SmallInteger one.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:57'!
testSmallIntegerMaxValue

	self assertSerializationIdentityOf: SmallInteger maxVal .
	! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:04'!
testSmallIntegerMinValue

	self assertSerializationIdentityOf: SmallInteger minVal ! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testSmallIntegerNegative

	self assertSerializationIdentityOf: -42.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/19/2010 14:47'!
testSmalltalkGlobal

	self assertSerializationIdentityOf: Transcript! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 12:23'!
testSmalltalkGlobalAssociation

	self assertSerializationIdentityOf: (Smalltalk associationAt: #Transcript)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:58'!
testString

	self assertSerializationEqualityOf: 'testString'! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:58'!
testSymbol

	self assertSerializationIdentityOf: #testSymbol! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:59'!
testTrue

	self assertSerializationIdentityOf: true! !

FLSerializationTest subclass: #FLClassSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/4/2010 16:35'!
testForeignClass
	"Tests the serialization of a class that is not being exported"
	
	self assertSerializationIdentityOf: Pair! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/15/2010 11:29'!
testForeignMetaclass
	"Tests the serialization of a Metaclass that is not being exported"
	
	self assertSerializationIdentityOf: Pair class! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/4/2010 16:52'!
testForeignTrait
	"Tests the serialization of a trait that is not being exported"
	
	self assertSerializationIdentityOf: TPureBehavior! !

FLSerializationTest subclass: #FLCompiledMethodSerializationTest
	instanceVariableNames: 'instanceVarForTesting'
	classVariableNames: 'ClassVariableForTesting'
	poolDictionaries: ''
	category: 'Fuel-Tests'!

FLCompiledMethodSerializationTest class
	instanceVariableNames: 'classInstanceVariableForTesting'!

FLCompiledMethodSerializationTest class
	instanceVariableNames: 'classInstanceVariableForTesting'!

!FLCompiledMethodSerializationTest classSide methodsFor: 'testing' stamp: 'MartinDias 10/7/2010 11:53'!
classInstanceVariableForTesting
	^ classInstanceVariableForTesting! !

!FLCompiledMethodSerializationTest classSide methodsFor: 'testing' stamp: 'MartinDias 10/7/2010 11:54'!
classInstanceVariableForTesting: anObject
	
	classInstanceVariableForTesting := anObject! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 14:08'!
atInstanceVarForTestingPut: anObject
	
	instanceVarForTesting := anObject ! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 14:08'!
classVariableForTesting
	
	^ ClassVariableForTesting! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 14:08'!
classVariableForTesting: anObject
	
	ClassVariableForTesting := anObject ! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 14:08'!
fortyTwo
	^ 42 ! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 14:08'!
fortyTwoBlockClosure
	^ [ self fortyTwo ] ! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/20/2010 14:56'!
globalVariableForTesting

	^ Smalltalk globals at: #FLGlobalVariableForTesting ! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/20/2010 14:56'!
globalVariableForTesting: anObject

	 Smalltalk globals at: #FLGlobalVariableForTesting put: anObject! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 15:31'!
materializedCompiledMethod: aCompiledMethod

	| materializedCompiledMethod |
	materializedCompiledMethod := self materialized: aCompiledMethod.
	
	self deny: aCompiledMethod == materializedCompiledMethod.

	"CompiledMethod>>= is too strict for us, so we check equality in this way"

	self flag: #todo. "fix ugly code"
	self assert: aCompiledMethod getSource asString withBlanksTrimmed 
		equals: materializedCompiledMethod getSource asString withBlanksTrimmed.

	self deny: aCompiledMethod getSource == materializedCompiledMethod getSource.

	self assert: aCompiledMethod header equals: materializedCompiledMethod header.

	self assert: aCompiledMethod initialPC equals: materializedCompiledMethod initialPC.

	^ materializedCompiledMethod! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/21/2010 13:53'!
tearDown

	super tearDown.
	Smalltalk globals removeKey: #FLGlobalVariableForTesting ifAbsent: []! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:19'!
testBasicMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: Object >> #yourself..

	self assert: self == (materializedCompiledMethod valueWithReceiver: self arguments: #()).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:22'!
testBlockClosureMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #fortyTwoBlockClosure.

	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #()) value
! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:24'!
testClassInstanceVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class class >> #classInstanceVariableForTesting:.

	self class classInstanceVariableForTesting: false.
	materializedCompiledMethod valueWithReceiver: self class arguments: { true }.
	self assert: self class classInstanceVariableForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:31'!
testClassVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #classVariableForTesting:.

	self classVariableForTesting: false.
	materializedCompiledMethod valueWithReceiver: self arguments: { true }.
	self assert: self classVariableForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:32'!
testGlobalVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #globalVariableForTesting:.
	
	self globalVariableForTesting: false.
	materializedCompiledMethod valueWithReceiver: self arguments: { true }.
	self assert: self globalVariableForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 14:57'!
testInstanceVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #atInstanceVarForTestingPut:.

	instanceVarForTesting := false.
	materializedCompiledMethod valueWithReceiver: self arguments: { true }.
	self assert: instanceVarForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/22/2010 12:19'!
testNamedPrimitiveMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: Integer >> #bitAnd:.

	self assert: 16r30 equals: (materializedCompiledMethod valueWithReceiver: 16r3F arguments: #(16rF0)).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:35'!
testPrimitiveMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: Object >> #perform:.

	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #(fortyTwo)).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:35'!
testSmallIntegerMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #fortyTwo.

	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #()).! !

FLSerializationTest subclass: #FLCrowdedSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLCrowdedSerializationTest commentStamp: '<historical>' prior: 0!
I have tests with large samples, so I'm very slow to be run frequently.!

!FLCrowdedSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:38'!
assertSerializationEqualityOfAll: rootsCollection

	| materializedRoots |
	materializedRoots := self materializedRootsOfAll: rootsCollection..		
	self assert: rootsCollection size equals: materializedRoots size.
	self should: [ rootsCollection includesAllOf: materializedRoots ]! !

!FLCrowdedSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/28/2010 12:04'!
testLotsOfIntegers

	| integers |
	integers := Set new.
	1 to: (2 raisedTo: 17) do: [ :index | integers add: index ].

	self assertSerializationEqualityOf: integers! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/21/2010 10:54'!
assertSerializationEqualityOf: anObject
	"Asserts that the original object and the materialized one are equal (but not the same)"

	| materialized |
	materialized := self materialized: anObject.
	self should: [ anObject ~~ materialized ].
	self assert: anObject equals: materialized! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/21/2010 10:54'!
assertSerializationIdentityOf: anObject
	"Asserts that the original object and the materialized one are the same"

	self should: [ anObject == (self materialized: anObject)  ]! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/28/2010 10:52'!
materialized: anObject
	"Returns the result of serializing and materializing anObject."

	| aByteArray aSerializer |

	aSerializer := FLSerializer on: (RWBinaryOrTextStream on: '') binary.
	aByteArray := (aSerializer serialize: anObject) stream contents.
	^ (FLMaterializer on: aByteArray readStream)
		materialize;
		root


"	Using ReferenceStream:
	
	| stream |

	stream := ReferenceStream on: (RWBinaryOrTextStream on: '') binary.
	stream nextPut: anObject.

	stream := ReferenceStream on:  stream contents readStream.
	^ stream next"! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 09:15'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance ! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitMetaclass: self! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/5/2010 10:58'!
fuelSerializer 
	^ FLMetaclassClusterSerializer instance.! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:06'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 14:38'!
fuelSerializer 

	^ FLByteArrayClusterSerializer instance! !

!LargeNegativeInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 15:09'!
fuelSerializer 

	^ FLLargeNegativeIntegerClusterSerializer instance.! !

Object subclass: #FLAnalyzer
	instanceVariableNames: 'objectCount analyzers clusteredMetalevelObjects clusteredBaselevelObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLAnalyzer commentStamp: '<historical>' prior: 0!
I am responsible of traverse the graph of references starting on a collection of root objects. I will produce dictionaries that associate each traversed object to a serializer.

An example of use is

	FLAnalyzer newDefault 
		analyzeAll: { 1@2. 3@4 };
		clusteredInstances.
	
The results are used by FLSerializer to serialize the analyzed objects into a stream.!

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:32'!
new

	self error: 'Should use an specific instance creation message.'! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:31'!
newDefault

	^ self basicNew 
		initialize; 
		initializeDefaultAnalyzers;
		yourself! !

!FLAnalyzer methodsFor: 'analyze' stamp: 'MartinDias 10/25/2010 15:07'!
analyze: anObject

	(self analyzerFor: anObject) value: anObject ! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 10:35'!
analyzerFor: anObject

	^ analyzers detect: [ :anAnalyzer | anAnalyzer analyzes: anObject ].
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 14:58'!
clusteredBaselevelObjects
	
	^ clusteredBaselevelObjects! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 14:58'!
clusteredMetalevelObjects
	
	^ clusteredMetalevelObjects ! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 15:44'!
clusteredObjects
	"Returns a new collection with all the clustered objects, in Association instances."
	
	^ (OrderedCollection new: clusteredMetalevelObjects size + clusteredBaselevelObjects size) 
		addAll: clusteredMetalevelObjects associations;
		addAll: clusteredBaselevelObjects associations;
		yourself.! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 10/19/2010 11:03'!
clusters: aDictionary add: anObject do: aBlock

	self
		clusters: aDictionary
		add: anObject
		serializer: anObject fuelSerializer
		do: aBlock! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 10/21/2010 14:43'!
clusters: aDictionary add: anObject serializer: aSerializer do: aBlock

	self clusters: aDictionary add: anObject serializer: aSerializer do: aBlock collectionFactoryBlock: [ IdentitySet new ]
! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 10/21/2010 14:43'!
clusters: aDictionary add: anObject serializer: aSerializer do: aBlock collectionFactoryBlock: aBlockForNewCollection

	| clusterSet |
	clusterSet := aDictionary at: aSerializer ifAbsentPut: [ aBlockForNewCollection value ].
	(clusterSet includes: anObject)
		ifTrue: [ ^ self ].
	clusterSet add: anObject.
	objectCount := objectCount + 1.
	aBlock value! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 11/3/2010 14:58'!
initialize

	clusteredBaselevelObjects := Dictionary new.
	clusteredMetalevelObjects := Dictionary new.
	objectCount := 0.
	analyzers := OrderedCollection new.
! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 10/26/2010 10:30'!
initializeDefaultAnalyzers

	analyzers 
		add: (FLGlobalAssociationAnalyzer newWith: self);
		add: (FLClassPoolAssociationAnalyzer newWith: self);
		add: (FLGlobalAnalyzer newWith: self);
		add: (FLDefaultAnalyzer newWith: self)
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 10:31'!
objectCount

	^ objectCount! !

Object subclass: #FLBenchmarks
	instanceVariableNames: 'benchWriteStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

FLBenchmarks class
	instanceVariableNames: 'instance'!

!FLBenchmarks commentStamp: 'MartinDias 11/3/2010 18:59' prior: 0!
I implement benchmarks for comparing Fuel with other ways of serializing and materializing.

To run, just do it on one of the following lines. The results will be written at Transcript.


FLBenchmarks instance runBenchWithSample: #strings
FLBenchmarks instance runBenchWithSample: #symbols
FLBenchmarks instance runBenchWithSample: #smallIntegers 
FLBenchmarks instance runBenchWithSample: #floats 

FLBenchmarks instance runBenchWithSample: #points
FLBenchmarks instance runBenchWithSample: #pairs
FLBenchmarks instance runBenchWithSample: #rectangles

FLBenchmarks instance runBenchWithSample: #completeBinaryTree

FLBenchmarks instance runBenchWithSample: #someMethods
FLBenchmarks instance runBenchWithSample: #primitiveMethods
FLBenchmarks instance runBenchWithSample: #methods

FLBenchmarks instance runBenchWithSample: #mooseDefaultModels !

FLBenchmarks class
	instanceVariableNames: 'instance'!

!FLBenchmarks classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/15/2010 13:12'!
initialize

	super initialize.
	instance := nil.! !

!FLBenchmarks classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/13/2010 13:58'!
instance
	"Returns the singleton instance of this class"
	
	^ instance ifNil: [ instance := self basicNew initialize ]
	
! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 11/3/2010 22:42'!
benchSelectors 

	^ #( 
		#runFuelBenchWith: 
		#runReferenceStreamBenchWith:
		#runFuelBenchWith: 
		#runReferenceStreamBenchWith:
		"#runSmartRefStreamBenchWith:" 
		"#runMagmaBenchWith:"
		"#runMC2BenchWith:")! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/15/2010 13:19'!
completeBinaryTree 
	| aCollection numberOfLeafs |
	numberOfLeafs := 2 raisedTo: 14.
	aCollection := OrderedCollection new.
	1 to: numberOfLeafs do: [ :i | 
		aCollection add: (
			Pair new 
				left: (2 * i); 
				right: (2 * i) + 1;
				yourself) ].
	
	[aCollection size > 1] 
		whileTrue: [
			aCollection := aCollection pairsCollect: [ :leftPair :rightPair | 
				Pair new 
					left: leftPair;
					right: rightPair;
					yourself ] ].
	^aCollection! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 17:35'!
floats

	^ (1 to: (2 raisedTo: 16)) collect: [ :i | i * 1.1 ]
! !

!FLBenchmarks methodsFor: 'initialize-release' stamp: 'MartinDias 10/27/2010 10:26'!
initialize 
	benchWriteStream := Transcript! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:37'!
methods

	^ Smalltalk allClasses 
		inject: OrderedCollection new 
		into: [ :aCollection :aClass | aCollection addAll: aClass methods. aCollection ].
! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/27/2010 15:33'!
mooseModelRoot

	MooseModel allInstances 
		ifEmpty: [ 
			MooseModel installDefaultModels.
			"MooseScripts createModelForPharo11PackagesCore.
	MooseScripts createModelForNetwork."].

	^ MooseModel root.
! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:25'!
pairs

	^ (1 to: 1 << 16) 
		collect: [ :i | 
			Pair new 
				left: i; 
				right: i+1;
				yourself ].
! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:25'!
points

	^ (1 to: 1 << 16) 
		collect: [ :i | i @ (i+1) ]! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:37'!
primitiveMethods

	^ SystemNavigation default allPrimitiveMethods! !

!FLBenchmarks methodsFor: 'protected' stamp: 'MartinDias 10/27/2010 20:56'!
readStreamFrom: aWriteStream

	"^ aWriteStream open reset"
	^ aWriteStream contents readStream! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:58'!
rectangles
	
	^ self rectanglesBy: 4! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:20'!
rectanglesBy: step
	"Returns rectangles sharing more or less integers, depending step is 1, 2, 3 or 4."

	^ (1 to: (2 raisedTo: 15) * step by: step) 
		collect: [ :i | i@(i+1) corner: (i+2)@(i+3) ]
! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:55'!
repeatedIntegersLessThan: anInteger

	^ (0 to: 1 << 16) collect: [ :i | i \\ anInteger ]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 11/3/2010 18:58'!
runAllBenchSamples

self runBenchWithSample: #strings.
self runBenchWithSample: #symbols.
self runBenchWithSample: #smallIntegers.
self runBenchWithSample: #floats.

self runBenchWithSample: #points.
self runBenchWithSample: #pairs.

self runBenchWithSample: #rectangles
! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 11/3/2010 22:26'!
runBenchWith: anObject

	self benchSelectors do: [ :aRunBenchmarkSelector |
		self perform: aRunBenchmarkSelector with: anObject.
		Smalltalk garbageCollect.
		benchWriteStream cr; flush.
	]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 11/3/2010 18:14'!
runBenchWithSample: aSampleSelector

	| sample |
	sample := self perform: aSampleSelector.

	benchWriteStream
		cr; cr;
		nextPutAll: '= Sample: ';
		nextPutAll: aSampleSelector asString;
		nextPutAll: ' size: ';
		nextPutAll: sample size printString;
		nextPutAll: ' =';
		cr; cr.

	self runBenchWith: sample! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/28/2010 11:16'!
runFuelBenchWith: anObject

	| serializer materializer writeStream readStream |

	writeStream := self writeStreamNamed: 'Fuel'.
	serializer := FLSerializer on: writeStream.
	self spy: [ serializer serialize: anObject ] title: 'Fuel Serialization'.
	writeStream close.

	readStream := self readStreamFrom: writeStream.
	materializer := FLMaterializer on: readStream.
	self spy: [ materializer materialize ] title: 'Fuel Materialization'.
	readStream close.! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/28/2010 11:16'!
runMC2BenchWith: anObject

"	This code needs to be updated.

	| serializer writeStream |

	writeStream := (RWBinaryOrTextStream on: '') binary.

	Transcript show: '= MC2 Serialization ='; cr.
	self spy: [
		serializer := MDSerializer on: writeStream. 
		serializer serialize: anObject ]
			putResultsOn: Transcript.

	Transcript show: '= MC2 Materialization ='; cr.
	self spy: [ 
		MDMaterializer materialize: writeStream contents ] 
			putResultsOn: Transcript."! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/28/2010 11:17'!
runMagmaBenchWith: anObject

"	This code needs to be updated.
	
	| aSerializer aGraphBuffer anotherSerializer aByteArray |
	
	writeStream nextPutAll: '= Magma Serialization ='; cr.
	aSerializer := MaObjectSerializer new.
	self spy: [ 
		aGraphBuffer := aSerializer serializeGraph: aCollection.
	].
 
	writeStream nextPutAll: '= Magma Materialization ='; cr.
	anotherSerializer := MaObjectSerializer new.
	aByteArray := aGraphBuffer byteArray copy.
	self spy: [ anotherSerializer materializeGraph: aByteArray ]"! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/28/2010 11:18'!
runReferenceStreamBenchWith: anObject

	| referenceStream writeStream readStream |

	writeStream := self writeStreamNamed: 'ReferenceStream'.
	referenceStream := ReferenceStream on: writeStream.
	self spy: [ referenceStream nextPut: anObject ] title: 'ReferenceStream Serialization'.
	writeStream close.

	readStream := self readStreamFrom: writeStream.
	referenceStream := ReferenceStream on: readStream.
	self spy: [ referenceStream next ] title: 'ReferenceStream Materialization'.
	readStream close.! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/28/2010 11:18'!
runSmartRefStreamBenchWith: anObject

"	This code needs to be updated.
	
	| stream materializedObjects |

	writeStream nextPutAll: '= SmartRefStream Serialization ='; cr.
	stream := SmartRefStream on: (RWBinaryOrTextStream on: '') binary.
	self spy: [
		stream nextPutAll: aCollection.
	].

	writeStream nextPutAll: '= SmartRefStream Materialization ='; cr.
	stream := SmartRefStream on:  stream contents readStream.
	materializedObjects := OrderedCollection new.
	self spy: [
		[ stream atEnd ] 
			whileFalse: [
				materializedObjects add: stream next ]
	]"! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:29'!
smallIntegers
	
	^ (1 to: 1 << 30 by: 1 << 12) asArray! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/25/2010 16:36'!
someMethods

	^ (SystemNavigation default allClassesInPackageNamed: 'System') 
		inject: Set new into: [ :aSet :aClass | aSet addAll: aClass methods. aSet ]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/27/2010 10:26'!
spy: aBlockClosure title: aTitle

	benchWriteStream 
		nextPutAll: aTitle;
		nextPutAll: ': ';
		nextPutAll: aBlockClosure timeToRun printString;
		nextPutAll: ' ms';
		cr. ! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:31'!
strings
	
	^ (1 to: 1 << 17) 
		collect: [ :index | (index * 123456790) asString ]! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 11/3/2010 18:35'!
symbols

	^ Symbol allSymbols "last: 1 << 15"! !

!FLBenchmarks methodsFor: 'protected' stamp: 'MartinDias 10/27/2010 20:56'!
writeStreamNamed: aName

	^ (RWBinaryOrTextStream on: '') binary
	"^ (StandardFileStream forceNewFileNamed: aName)
		binary"! !

Object subclass: #FLClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLClusterSerializer class
	instanceVariableNames: 'instance serializersById'!

!FLClusterSerializer commentStamp: '<historical>' prior: 0!
I represent a special way of serialize and materialize some specific kind of objects.

Each of my non-abstract subclasses answers to #id with an unique integer, that identifies it. 

Sending me the #forId: message you obtain an instance that corresponds with an specific id. 

Every object responds to #fuelSerializer with its corresponding subclass of me. For example:

	42 fuelSerializer 
	
will return a serializer for SmallInteger.!

FLClusterSerializer class
	instanceVariableNames: 'instance serializersById'!

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:24'!
allSubclassesWithId
	"Answers a collection with all the subclasses that define an id. In other words, all the non-abstract subclasses are returned"

	^self allSubclasses select: [ :aClass | 
			[ aClass id isInteger ] ifError: [ false ] ] 
	! !

!FLClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 12:34'!
forId: anInteger
	"Returns the serializer instance that corresponds to the id received"

	^ self serializersById 
			at: anInteger 
			ifAbsent: [ self error: 'Could not find a serializer with id=', anInteger asString ].
	
! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:56'!
id
	"Answer an integer identifier. It must be between 0 and 255. 
	Each type of primitive object should have a different one. 
	validateIdDistribution checks that there is no overlap."
	
	self subclassResponsibility ! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/15/2010 13:11'!
initialize
	"Initializes singleton class variables"

	super initialize.
	instance := nil.
	serializersById := nil.! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/19/2010 16:41'!
initializeHierarchy
	"Initializes class variables in the whole hierarchy"

	self withAllSubclasses do: [ :x | x initialize ].  ! !

!FLClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/15/2010 11:29'!
instance
	"Returns the singleton instance of this class. It may not be sent to abstract classes, see class doc."
	
	^ instance ifNil: [ instance := self basicNew initialize ]
	
! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:16'!
serializersById
	"Returns a dictionary that indexes the serializers by their ids"

	serializersById ifNil: [
			serializersById := IdentityDictionary new.
			self allSubclassesWithId 
				do: [ :aSerializerClass | 
					serializersById 
						at: aSerializerClass id 
						put: aSerializerClass instance ] ].
	^ serializersById 
! !

!FLClusterSerializer classSide methodsFor: 'checking' stamp: 'MartinDias 10/12/2010 16:06'!
validateIdDistribution
	"Verifies that subclasses do not have overlapping ids"
	
	self assert: (self allSubclassesWithId collect: [ :aClass | aClass id ]) hasAnyDuplicate not
		description: 'Overlapping id detected in FLClusterSerializer subclasses'! !

!FLClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:35'!
materializeAllWith: aMaterializer

	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:11'!
serializeAll: clusterInstances with: aSerializer

	self subclassResponsibility ! !

FLClusterSerializer subclass: #FLIteratingClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLIteratingClusterSerializer commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects consists on delegate the serialization of each individual object to the subclass.!

FLIteratingClusterSerializer subclass: #FLClassPoolAssociationClusterSerializer
	instanceVariableNames: 'ownerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClassPoolAssociationClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for variable bindings that belong to the class pool of a Class included on Smalltalk globals.!

!FLClassPoolAssociationClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 18:02'!
id

	^ 20! !

!FLClassPoolAssociationClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 17:55'!
newFor: aClass

	^ self basicNew
		initialize;
		ownerClass: aClass;
		yourself.! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 18:07'!
materializeWith: aMaterializer

	| keyName |
	ownerClass := aMaterializer nextReferencedObject.
	keyName := aMaterializer stream nextString.
	^ ownerClass classPool associationAt: keyName asSymbol ! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 17:59'!
ownerClass: anObject
	ownerClass := anObject! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 18:07'!
serialize: anAssociation with: aSerializer

	aSerializer nextPutReferenceTo: ownerClass.
	aSerializer stream nextStringPut: anAssociation key asString! !

FLIteratingClusterSerializer subclass: #FLCompiledMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCompiledMethodClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for CompiledMethod instances.!

!FLCompiledMethodClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:19'!
id
	^2! !

!FLCompiledMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLCompiledMethodClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:43'!
materializeWith: aMaterializer

	| compiledMethod header source trailer numberOfBytesForAllButTrailer aReadStream |

	aReadStream := aMaterializer stream.

	header := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.
	numberOfBytesForAllButTrailer := aReadStream nextWord.
	"source := aReadStream nextString."
	source := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.

	trailer := CompiledMethodTrailer new 
		"sourceCode: source;" 
		sourcePointer: source;
		yourself.

	compiledMethod := trailer createMethod: numberOfBytesForAllButTrailer header: header.

	compiledMethod initialPC - 1 to: numberOfBytesForAllButTrailer
		do: [ :index | compiledMethod at: index put: aReadStream next ].

	aMaterializer referenceMaterializingActionsAdd: 
		[ self materializeLiteralsTo: compiledMethod with: aMaterializer ].
		
	^ compiledMethod! !

!FLCompiledMethodClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:43'!
serialize: aCompiledMethod with: aSerializer

	| header source aWriteStream numberOfBytesForAllButTrailer |

	aWriteStream := aSerializer stream.

	header := aCompiledMethod header.
	numberOfBytesForAllButTrailer := aCompiledMethod size - aCompiledMethod trailer size.
	"source := aCompiledMethod getSource."
	source := aCompiledMethod sourcePointer.

	aWriteStream 
		nextWordPut: (header >> 16);
		nextWordPut: header;
		nextWordPut: numberOfBytesForAllButTrailer;
		"nextStringPut: source asString."
		nextWordPut: (source >> 16);
		nextWordPut: source.

	aCompiledMethod initialPC - 1 to: aCompiledMethod endPC
		do: [ :index | aWriteStream nextPut: (aCompiledMethod at: index) ].

	aSerializer referenceSerializingActionsAdd: 
		[ self serializeLiteralsOf: aCompiledMethod with: aSerializer ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	1 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

FLCompiledMethodClusterSerializer subclass: #FLNamedPrimitiveMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNamedPrimitiveMethodClusterSerializer commentStamp: 'MartinDias 11/2/2010 15:33' prior: 0!
I am a serializer for CompiledMethods which are <primitive:module:> primitives.

For example, Integer >> bitAnd: should be serialized with me.!

!FLNamedPrimitiveMethodClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/22/2010 12:08'!
id

	^ 23! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/22/2010 12:20'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	| module name |
	module := aMaterializer nextReferencedObject.
	name := aMaterializer nextReferencedObject.
	compiledMethod literalAt: 1 put: {module. name. 0. 0} asArray.

	2 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 14:43'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	| primitiveArguments |
	
	primitiveArguments := aCompiledMethod literalAt: 1.
	aSerializer 
		nextPutReferenceTo: primitiveArguments first;
		nextPutReferenceTo: primitiveArguments second.

	2 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:27'!
materializeAllWith: aMaterializer
	"Template method that let to the subclass the materialization using the received materializer"

	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeWith: aMaterializer) ].! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeWith: aMaterializer
	"Hook method that each subclass should customize for its special way of materializing"

	^ self subclassResponsibility! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
serialize: aMetaclass with: aSerializer
	"Hook method that each subclass should customize for its special way of serializing"

	self subclassResponsibility ! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:27'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"

	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance with: aSerializer ]! !

FLIteratingClusterSerializer subclass: #FLMetaclassClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLMetaclassClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Metaclasses.!

!FLMetaclassClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id
	^ 12! !

!FLMetaclassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/5/2010 14:28'!
materializeWith: aMaterializer

	^ aMaterializer nextReferencedObject class.! !

!FLMetaclassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/5/2010 14:28'!
serialize: aMetaclass with: aSerializer

	aSerializer nextPutReferenceTo: aMetaclass soleInstance.
! !

FLClusterSerializer subclass: #FLObjectClusterSerializer
	instanceVariableNames: 'clusteredClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLObjectClusterSerializer commentStamp: '<historical>' prior: 0!
I implement a generic way of serializing and materializing an object, for those that do not need more special way of doing it.

For example,

	10@20 fuelSerializer 

returns an instance of me.

!

!FLObjectClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/12/2010 12:54'!
for: aClass

	^ self basicNew
		clusteredClass: aClass;
		yourself.! !

!FLObjectClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^0! !

!FLObjectClusterSerializer methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 11:00'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self clusteredClass = anObject clusteredClass! !

!FLObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 12:54'!
clusteredClass
	^ clusteredClass ! !

!FLObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 12:54'!
clusteredClass: aClass

	clusteredClass := aClass! !

!FLObjectClusterSerializer methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 11:00'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self clusteredClass hash! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:30'!
materializeAllWith: aMaterializer

	| instanceCount class clusterInstances |

	class := aMaterializer nextReferencedObject.
	instanceCount := aMaterializer nextInteger.
	clusterInstances := OrderedCollection new: instanceCount.

	class isVariable
		ifTrue: [ 
			instanceCount timesRepeat: [ clusterInstances add: (class basicNew: aMaterializer nextInteger) ].
			aMaterializer referenceMaterializingActionsAdd: [ 
				self materializeVariableReferencesOfAll: clusterInstances with: aMaterializer ] ]
		ifFalse: [ 
			instanceCount timesRepeat: [ clusterInstances add: class basicNew ] ].

	class hasInstanceVariables
		ifTrue: [ 
			aMaterializer referenceMaterializingActionsAdd: [ 
				self flag: #todo. "Singleton with state, not good"
				clusteredClass := class.
				self materializeReferencesOfAll: clusterInstances with: aMaterializer ] ].
		
	aMaterializer addAllMaterialized: clusterInstances! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/13/2010 11:37'!
materializeReferencesOfAll: instances with: aMaterializer
	
	instances
		do: [ :instance |
			1 to: clusteredClass instSize  
				do: [ :index | instance instVarAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/25/2010 14:05'!
materializeVariableReferencesOfAll: instances with: aMaterializer
	instances
		do: [ :instance |
			1 to: instance basicSize 
				do: [ :index | instance basicAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/15/2010 10:43'!
serializeAll: clusterInstances with: aSerializer

	aSerializer nextPutReferenceTo: clusteredClass.
	aSerializer nextPutInteger: clusterInstances size.

	clusteredClass isVariable
		ifTrue: [ 
			clusterInstances do: [ :instance | aSerializer nextPutInteger: instance basicSize ].
			aSerializer referenceSerializingActionsAdd:
				[ self serializeVariableReferencesOfAll: clusterInstances with: aSerializer ] ].

	clusteredClass hasInstanceVariables
		ifTrue: [ 
			aSerializer referenceSerializingActionsAdd:
				[ self serializeReferencesOfAll: clusterInstances with: aSerializer ] ]! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/13/2010 11:13'!
serializeReferencesOfAll: instances with: aSerializer 
	
	instances 
		do: [ :anInstance |
			1 to: clusteredClass instSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance instVarAt: index) ]]
				
	! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/13/2010 11:14'!
serializeVariableReferencesOfAll: instances with: aSerializer

	instances 
		do: [ :anInstance |
			1 to: anInstance basicSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance basicAt: index) ]]! !

FLClusterSerializer subclass: #FLPrimitiveClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLPrimitiveClusterSerializer commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects is to delegate the serialization of each individual object to the subclass. 

(TODO) My main difference with FLIteratingClusterSerializer is that my method hooks only receive a stream and not the complete instance of FLSerializer, because they have not need. But possibly there is no reason for being different classes.!

FLPrimitiveClusterSerializer subclass: #FLByteArrayClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteArrayClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for ByteArray.!

!FLByteArrayClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 14:37'!
id

	^25! !

!FLByteArrayClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 14:37'!
materializeFrom: aReadStream

	^ aReadStream nextString asByteArray! !

!FLByteArrayClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 14:37'!
serialize: aByteArray on: aWriteStream

	aWriteStream nextStringPut: aByteArray asString ! !

FLPrimitiveClusterSerializer subclass: #FLByteStringClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteStringClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for ByteString.!

!FLByteStringClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 13:32'!
id

	^24! !

!FLByteStringClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
materializeFrom: aReadStream

	^ aReadStream nextString! !

!FLByteStringClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
serialize: aString on: aWriteStream

	aWriteStream nextStringPut: aString! !

FLPrimitiveClusterSerializer subclass: #FLCharacterClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCharacterClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Character.!

!FLCharacterClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^1! !

!FLCharacterClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:06'!
materializeFrom: aReadStream

	^Character value: aReadStream next! !

!FLCharacterClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/27/2010 13:44'!
serialize: aCharacter on: aWriteStream

	aWriteStream nextPut: aCharacter value.! !

FLPrimitiveClusterSerializer subclass: #FLFloatClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLFloatClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for 8-byte Floats. 

Implementation took from ReferenceStream.
!

!FLFloatClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 22:45'!
id
	^21! !

!FLFloatClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 13:27'!
materializeFrom: aReadStream

	^ (Float new: 2)
		at: 1 put: (aReadStream nextNumber: 4);
		at: 2 put: (aReadStream nextNumber: 4);
		yourself.
! !

!FLFloatClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 10:39'!
serialize: aFloat on: aWriteStream

	aWriteStream 
		nextNumber: 4 put: (aFloat at: 1);
		nextNumber: 4 put: (aFloat at: 2).! !

FLPrimitiveClusterSerializer subclass: #FLGlobalAssociationClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalAssociationClusterSerializer commentStamp: '<historical>' prior: 0!
I serialize variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
could be serialized by me.!

!FLGlobalAssociationClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 12:16'!
id
	^ 19! !

!FLGlobalAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 15:08'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		associationAt: aReadStream nextString asSymbol
		ifAbsent: [ self error: 'Association not found.' ] ! !

!FLGlobalAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 12:10'!
serialize: anAssociation on: aWriteStream
	
	aWriteStream nextStringPut: anAssociation key! !

FLPrimitiveClusterSerializer subclass: #FLGlobalClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for classes and well known objects that belong to Smalltalk global dictionary.

For example, Transcript could be serialized by me.!

!FLGlobalClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^ 11! !

!FLGlobalClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 14:52'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		at: aReadStream nextString asSymbol 
		ifAbsent: [ self error: 'Smalltalk global not found' ]! !

!FLGlobalClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 14:52'!
serialize: anObject on: aWriteStream
	
	aWriteStream 
		nextStringPut: (Smalltalk globals keyAtValue: anObject) asString.! !

FLPrimitiveClusterSerializer subclass: #FLLargeNegativeIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargeNegativeIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for LargeNegativeInteger.!

!FLLargeNegativeIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^8! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size := aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value negated ! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:44'!
serialize: anInteger on: aWriteStream

	| size byte positive |
	positive := anInteger abs.
	size := (positive log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
			byte := (positive bitShift: index * -8) bitAnd: 255.
			aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLLargePositiveIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargePositiveIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for LargePositiveInteger.!

!FLLargePositiveIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^7! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/27/2010 13:42'!
serialize: anInteger on: aWriteStream

	| size byte |
	size:=(anInteger log: 256) floor + 1.
	aWriteStream nextPut: size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLNegativeSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNegativeSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for negative SmallInteger instances.!

!FLNegativeSmallIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^10! !

!FLNegativeSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ ((hi bitShift: 24) + (mid2 bitShift: 16) + (mid1 bitShift: 8) + lo) negated! !

!FLNegativeSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:38'!
serialize: anInteger on: aWriteStream

	| aPositiveInteger |
	aPositiveInteger := anInteger abs.
	aWriteStream nextPut: (aPositiveInteger bitShift: -24).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (aPositiveInteger bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLNilTrueFalseClusterSerializer
	instanceVariableNames: 'wellKnownObjectsDictionary'
	classVariableNames: 'WellKnownObjectsDictionary'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNilTrueFalseClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for nil, true and false. They have a special treatment because they are so common in the image.!

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 12:20'!
id

	^4! !

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/19/2010 12:22'!
initialize 

	super initialize.
	WellKnownObjectsDictionary := Dictionary new
		add: 1 -> nil;
		add: 2 -> true;
		add: 3 -> false;
		yourself.! !

!FLNilTrueFalseClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 12:21'!
materializeFrom: aReadStream
	
	^ WellKnownObjectsDictionary at: aReadStream next
	! !

!FLNilTrueFalseClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 13:30'!
serialize: aWellKnownObject on: aWriteStream

	aWriteStream nextPut: (WellKnownObjectsDictionary keyAtValue: aWellKnownObject)! !

FLPrimitiveClusterSerializer subclass: #FLPositiveSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLPositiveSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for positive SmallInteger instances.!

!FLPositiveSmallIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^9! !

!FLPositiveSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/15/2010 10:51'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ (((hi bitShift: 24) bitXor: (mid2 bitShift: 16)) bitXor: (mid1 bitShift: 8)) bitXor: lo! !

!FLPositiveSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/24/2010 00:48'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -24).
	aWriteStream nextPut: ((anInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((anInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:28'!
materializeAllWith: aMaterializer 
	"Template method that let to the subclass the materialization using the received materializer"
	
	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeFrom: aMaterializer stream) ].! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeFrom: aReadStream
	"Hook method that each subclass should customize for its special way of materializing"
	
	self subclassResponsibility ! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:29'!
serialize: anObject on: aWriteStream
	"Hook method that each subclass should customize for its special way of serializing"
	
	self subclassResponsibility! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:28'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"
	
	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance on: aSerializer stream ]! !

FLPrimitiveClusterSerializer subclass: #FLSymbolClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSymbolClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Symbol instances.!

!FLSymbolClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id

	^3! !

!FLSymbolClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/26/2010 14:22'!
materializeFrom: aReadStream

	^ aReadStream nextString asSymbol! !

!FLSymbolClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/26/2010 14:22'!
serialize: aSymbol on: aWriteStream

	aWriteStream nextStringPut: aSymbol asString! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream referenceMaterializingActions materializedInstances integerMaterializer materializedRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer commentStamp: '<historical>' prior: 0!
I am a binary object materializer. 

By sending me #materialize, I will recreate previously serialized objects by FLSerializer from a byte stream. The results are obtained sending #materializedRoots.

!

!FLMaterializer class methodsFor: 'creation' stamp: 'MartinDias 9/20/2010 20:34'!
on: aReadStream

	^self new
		stream: aReadStream; 
		yourself
! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:31'!
addAllMaterialized: aCollection
	
	materializedInstances addAll: aCollection ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:24'!
addMaterialized: anObject
	
	materializedInstances add: anObject ! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 16:12'!
clusterSerializerFor: id

	^ FLClusterSerializer forId: id.! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'MartinDias 10/12/2010 16:29'!
initialize 
	
	super initialize.
	referenceMaterializingActions := OrderedCollection new.! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MartinDias 10/28/2010 10:51'!
materialize

	self materializeInstances.
	self materializeReferences.
	self materializeRoot.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/15/2010 13:04'!
materializeCluster
	| clusterSerializerId clusterSerializer |
	clusterSerializerId := stream nextWord.
	clusterSerializer := self clusterSerializerFor: clusterSerializerId.
	clusterSerializer materializeAllWith: self! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/4/2010 22:31'!
materializeInstances

	| clusterCount objectCount |

	integerMaterializer := self clusterSerializerFor: stream nextWord.

	objectCount := self nextInteger.
	materializedInstances := OrderedCollection new: objectCount.

	clusterCount := self nextInteger.
	clusterCount timesRepeat: [self materializeCluster].
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:08'!
materializeReferences

	referenceMaterializingActions
		do: [ :aBlock | aBlock value ]
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:39'!
materializeRoot

	materializedRoot := self nextReferencedObject! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 21:39'!
nextInteger
	^ integerMaterializer materializeFrom: stream! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 21:39'!
nextReferencedObject 

	| referenceIndex |
	referenceIndex := integerMaterializer materializeFrom: stream.
	^ materializedInstances at: referenceIndex.! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceMaterializingActionsAdd: aBlock
	"Adds an action for being valued at the references materializing step"
	
	referenceMaterializingActions add: aBlock ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/28/2010 10:51'!
root

	^ materializedRoot ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2010 19:50'!
stream
	^ stream! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

Object subclass: #FLObjectAnalyzer
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLObjectAnalyzer commentStamp: '<historical>' prior: 0!
The purpose of my hierarchy is to collaborate with an Analyzer to traverse a graph of objects assigning to each of them an adequate FLClusterSerializer.!

FLObjectAnalyzer subclass: #FLClassPoolAssociationAnalyzer
	instanceVariableNames: 'classPoolBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLClassPoolAssociationAnalyzer commentStamp: '<historical>' prior: 0!
I analyze variable bindings that belong to the class pool of a Class existent on Smalltalk globals.!

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ anObject isVariableBinding and: [ self classPoolBindings includesKey: anObject ]! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:10'!
classPoolBindings

	^ classPoolBindings ifNil: [
			classPoolBindings := Dictionary new.
			Smalltalk allClassesAndTraitsDo: [ :aClass | 
				aClass classPool associationsDo: [ :aBinding | 
					classPoolBindings at: aBinding put: aClass ] ].
			classPoolBindings ]! !

!FLClassPoolAssociationAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 11/3/2010 14:57'!
value: anObject

	| ownerClass |
	ownerClass  := classPoolBindings at: anObject.

	analyzer 
		clusters: analyzer clusteredBaselevelObjects
		add: anObject  
		serializer: (FLClassPoolAssociationClusterSerializer newFor: ownerClass)
		do: [ analyzer analyze: ownerClass ]! !

FLObjectAnalyzer subclass: #FLDefaultAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLDefaultAnalyzer commentStamp: '<historical>' prior: 0!
I analyze objects using the serializer specified by each's #fuelSerializer message. 

I use the visitor pattern because I'm quite coupled to each serializer implementation. (TODO) Maybe this design must be changed.

Any object could be analyzed by me.!

!FLDefaultAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ true! !

!FLDefaultAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/20/2010 15:40'!
value: anObject

	anObject fuelAccept: self! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/26/2010 10:17'!
visitClassOrTrait: aClassOrTrait
	"Visits a Class or a Trait that should be fully serialized."
	
	self shouldBeImplemented ! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/3/2010 14:57'!
visitMetaclass: aMetaclass

	analyzer  
		clusters: analyzer clusteredBaselevelObjects 
		add: aMetaclass 
		do: [ analyzer analyze: aMetaclass soleInstance ]! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/3/2010 14:57'!
visitNilTrueFalse: anObject
	"Visits these singleton objects. They has a special treatment because they are so common. And also nil is special because it cannot be added to a Set like the other objects."

	analyzer 
		clusters: analyzer clusteredBaselevelObjects 
		add: anObject 
		serializer: anObject fuelSerializer 
		do: [] 
		collectionFactoryBlock: [ OrderedCollection new ]! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/3/2010 14:57'!
visitObject: anObject
	"Visits an object in the most generic way"

	analyzer
		clusters: analyzer clusteredBaselevelObjects
		add: anObject
		do: [ 
			analyzer analyze: anObject class.
			anObject fuelAllInstanceVariablesDo: [ :aChild | analyzer analyze: aChild ] ]! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/3/2010 14:57'!
visitPrimitive: anObject
	"Visits the objects who do not depend on others"

	analyzer 
		clusters: analyzer clusteredBaselevelObjects 
		add: anObject 
		do: []! !

FLObjectAnalyzer subclass: #FLGlobalAnalyzer
	instanceVariableNames: 'globalObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLGlobalAnalyzer commentStamp: '<historical>' prior: 0!
I analyze classes and well known objects that belong to Smalltalk global dictionary.

For example, Transcript is analyzed by me.!

!FLGlobalAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 19:54'!
analyzes: anObject

	^ globalObjects includes: anObject! !

!FLGlobalAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 10/28/2010 10:44'!
initialize

	globalObjects := IdentitySet newFrom: ((#(#Display #World #Smalltalk #Transcript #SourceFiles #Processor
		#ImageImports #TextConstants #Undeclared 
		#SystemOrganization #Sensor #ActiveWorld)
			collect: [ :key | Smalltalk globals at: key ]) 
			union: Smalltalk allClassesAndTraits)! !

!FLGlobalAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/20/2010 15:40'!
value: anObject

	anObject fuelAccept: self! !

!FLGlobalAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/3/2010 14:56'!
visitClassOrTrait: aClassOrTrait

	analyzer  
		clusters: analyzer clusteredMetalevelObjects 
		add: aClassOrTrait 
		serializer: FLGlobalClusterSerializer instance 
		do: [].! !

!FLGlobalAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/3/2010 14:56'!
visitObject: anObject

	analyzer 
		clusters: analyzer clusteredMetalevelObjects
		add: anObject  
		serializer: FLGlobalClusterSerializer instance 
		do: []! !

FLObjectAnalyzer subclass: #FLGlobalAssociationAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLGlobalAssociationAnalyzer commentStamp: '<historical>' prior: 0!
I analyze variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
is analyzed by me.!

!FLGlobalAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ anObject isVariableBinding and: [Smalltalk globals includesAssociation: anObject ].
! !

!FLGlobalAssociationAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 11/3/2010 14:56'!
value: anObject

	analyzer 
		clusters: analyzer clusteredMetalevelObjects
		add: anObject  
		serializer: FLGlobalAssociationClusterSerializer instance 
		do: []! !

!FLObjectAnalyzer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/20/2010 15:46'!
newWith: anAnalyzer

	^ self basicNew
		initialize;
		analyzer: anAnalyzer;
		yourself! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer
	^ analyzer! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer: anObject
	analyzer := anObject! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:23'!
analyzes: anObject
	"Tells if the received object is handled by this analyzer"

	self subclassResponsibility ! !

!FLObjectAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/25/2010 15:20'!
value: anObject
	"Executes the analysis on the object received."

	self subclassResponsibility ! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream instanceIndexes referenceSerializingActions integerSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer commentStamp: '<historical>' prior: 0!
I am a binary object serializer. 

By sending me #serializeAll: with a collection of objects as argument, I will write them on a byte stream, such that later a FLMaterializer instance will be able to read the stream and recreate the objects in the same or another image.!

!FLSerializer class methodsFor: 'instance creation' stamp: 'sd 9/8/2010 14:59'!
on: aWriteStream

	| serializer |
	serializer := self new.
	serializer stream: aWriteStream.
	^serializer.! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MartinDias 10/4/2010 22:48'!
initialize 

	instanceIndexes := IdentityDictionary new.
	referenceSerializingActions := OrderedCollection new.! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:53'!
nextPutInteger: anInteger

	integerSerializer serialize: anInteger on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:52'!
nextPutReferenceTo: anObject

	integerSerializer serialize: (instanceIndexes at: anObject) on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceSerializingActionsAdd: aBlock
	"Adds an action for being valued at the references serializing step"
	
	referenceSerializingActions add: aBlock ! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 11/3/2010 15:28'!
serialize: anObject 
	"Serializes using the default analyzer"

	self serialize: anObject analyzer: FLAnalyzer newDefault! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 11/3/2010 15:29'!
serialize: anObject analyzer: anAnalyzer
	"Main message for serializing"

	| objectCount clusteredObjects |
	anAnalyzer analyze: anObject.

	clusteredObjects := anAnalyzer clusteredObjects.
	objectCount := anAnalyzer objectCount.
	integerSerializer := objectCount fuelSerializer.

	self serializeHeaderWith: clusteredObjects and: objectCount.
	self serializeInstances: clusteredObjects.
	self serializeReferences.
	self serializeRoot: anObject.
! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 11/3/2010 15:18'!
serializeHeaderWith: clusteredObjects and: objectCount

	stream nextWordPut: integerSerializer class id.
	self nextPutInteger: objectCount.
	self nextPutInteger: clusteredObjects size! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 11/3/2010 15:30'!
serializeInstances: clusteredInstances
	clusteredInstances
		do: [ :anAssociation | 
			| serializer instances |
			serializer := anAssociation key.
			instances := anAssociation value.

			stream nextWordPut: serializer class id.
			serializer serializeAll: instances with: self.
			instances do: [ :instance | instanceIndexes at: instance put: instanceIndexes size + 1 ] ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:04'!
serializeReferences

	referenceSerializingActions 
		do: [ :aBlock | aBlock value ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:36'!
serializeRoot: anObject

	self nextPutReferenceTo: anObject! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream: anObject
	stream := anObject! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 16:49'!
fuelAccept: aVisitor

	aVisitor visitObject: self.
! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 10/18/2010 15:09'!
fuelAllInstanceVariablesDo: aBlock

	self class isVariable 
		ifTrue: [ 
			1 to: self basicSize 
				do: [ :index | aBlock value: (self basicAt: index) ] ].
	
	1 to: self class instSize 
		do: [ :index | aBlock value: (self instVarAt: index) ]! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/24/2010 01:36'!
fuelSerializer

	^ FLObjectClusterSerializer for: self class! !

Object subclass: #Pair
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!Pair methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 10:54'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self right = anObject right and: [ self left = anObject left ]! !

!Pair methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 10:54'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self right hash bitXor: self left hash! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left
	^ left! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left: anObject
	left := anObject! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right
	^ right! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right: anObject
	right := anObject! !
FLBenchmarks initialize!
FLClusterSerializer initialize!
FLNilTrueFalseClusterSerializer initialize!
